8138817: JNI warnings loading fonts on MacOSX
authorprr
Thu, 29 Oct 2015 15:17:57 -0700
changeset 33857 7d8b70202b18
parent 33856 875f59862274
child 33858 7554d0e25d7f
8138817: JNI warnings loading fonts on MacOSX Reviewed-by: serb, alexsch
jdk/src/java.desktop/macosx/native/libawt_lwawt/font/AWTFont.m
jdk/test/java/awt/font/JNICheck/LoadFontsJNICheck.java
jdk/test/java/awt/font/JNICheck/LoadFontsJNICheck.sh
--- a/jdk/src/java.desktop/macosx/native/libawt_lwawt/font/AWTFont.m	Thu Oct 29 18:43:21 2015 +0300
+++ b/jdk/src/java.desktop/macosx/native/libawt_lwawt/font/AWTFont.m	Thu Oct 29 15:17:57 2015 -0700
@@ -307,6 +307,8 @@
 
         JNFCallVoidMethod(env, jthis,
                           jm_registerFont, jFontName, jFontFamilyName);
+        (*env)->DeleteLocalRef(env, jFontName);
+        (*env)->DeleteLocalRef(env, jFontFamilyName);
     }
 
 JNF_COCOA_EXIT(env);
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/jdk/test/java/awt/font/JNICheck/LoadFontsJNICheck.java	Thu Oct 29 15:17:57 2015 -0700
@@ -0,0 +1,28 @@
+/*
+ * Copyright (c) 2015, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+public class LoadFontsJNICheck {
+    public static void main(String[] args) throws Exception {
+    java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment().getAllFonts();
+ }
+}
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/jdk/test/java/awt/font/JNICheck/LoadFontsJNICheck.sh	Thu Oct 29 15:17:57 2015 -0700
@@ -0,0 +1,62 @@
+#!/bin/sh
+#
+# Copyright (c) 2015, Oracle and/or its affiliates. All rights reserved.
+# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+#
+# This code is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 2 only, as
+# published by the Free Software Foundation.
+#
+# This code is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# version 2 for more details (a copy is included in the LICENSE file that
+# accompanied this code).
+#
+# You should have received a copy of the GNU General Public License version
+# 2 along with this work; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+# or visit www.oracle.com if you need additional information or have any
+# questions.
+
+#
+#   @test
+#   @bug        8138817
+#   @summary    Tests that there are no JNI warnings about local references.
+#   @compile LoadFontsJNICheck.java
+#   @run shell/timeout=300 LoadFontsJNICheck.sh
+#
+OS=`uname`
+
+# pick up the compiled class files.
+if [ -z "${TESTCLASSES}" ]; then
+  CP="."
+else
+  CP="${TESTCLASSES}"
+fi
+
+if [ $OS != Darwin ]
+then
+    exit 0
+fi
+
+if [ -z "${TESTJAVA}" ] ; then
+   JAVACMD=java
+else
+   JAVACMD=$TESTJAVA/bin/java
+fi
+
+$JAVACMD ${TESTVMOPTS} \
+    -cp "${CP}" -Xcheck:jni LoadFontsJNICheck | grep "local refs"  > "${CP}"/log.txt
+
+# any messages logged may indicate a failure.
+if [ -s "${CP}"/log.txt ]; then
+    echo "Test failed"
+    cat "${CP}"/log.txt
+    exit 1
+fi
+
+echo "Test passed"
+exit 0